/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : PTC0_Debug_Pin.h
**     Project     : ClassD-V1_2
**     Processor   : MKV10Z32VLF7
**     Component   : BitIO
**     Version     : Component 02.086, Driver 01.00, CPU db: 3.50.001
**     Repository  : Kinetis
**     Compiler    : GNU C Compiler
**     Date/Time   : 2015-06-12, 19:11, # CodeGen: 203
**     Abstract    :
**         This component "BitIO" implements an one-bit input/output.
**         It uses one bit/pin of a port.
**         Note: This component is set to work in Output direction only.
**         Methods of this component are mostly implemented as a macros
**         (if supported by target language and compiler).
**     Settings    :
**          Component name                                 : PTC0_Debug_Pin
**          Pin for I/O                                    : ADC1_SE11/PTC0/SPI0_PCS4/PDB0_EXTRG/CMP0_OUT/FTM0_FLT0/SPI0_PCS0/SS_b
**          BitIO_LDD                                      : BitIO_LDD
**          Direction                                      : Output
**          Initialization                                 : 
**            Init. direction                              : Output
**            Init. value                                  : 0
**          Safe mode                                      : yes
**          Optimization for                               : speed
**     Contents    :
**         GetVal - bool PTC0_Debug_Pin_GetVal(void);
**         PutVal - void PTC0_Debug_Pin_PutVal(bool Val);
**         ClrVal - void PTC0_Debug_Pin_ClrVal(void);
**         SetVal - void PTC0_Debug_Pin_SetVal(void);
**         NegVal - void PTC0_Debug_Pin_NegVal(void);
**
**     Copyright : 1997 - 2015 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file PTC0_Debug_Pin.h
** @version 01.00
** @brief
**         This component "BitIO" implements an one-bit input/output.
**         It uses one bit/pin of a port.
**         Note: This component is set to work in Output direction only.
**         Methods of this component are mostly implemented as a macros
**         (if supported by target language and compiler).
*/         
/*!
**  @addtogroup PTC0_Debug_Pin_module PTC0_Debug_Pin module documentation
**  @{
*/         

#ifndef __PTC0_Debug_Pin_H
#define __PTC0_Debug_Pin_H

/* MODULE PTC0_Debug_Pin. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "BitIoLdd5.h"

#include "Cpu.h"

#ifdef __cplusplus
extern "C" {
#endif 




/*
** ===================================================================
**     Method      :  PTC0_Debug_Pin_GetVal (component BitIO)
**     Description :
**         This method returns an input value.
**           a) direction = Input  : reads the input value from the
**                                   pin and returns it
**           b) direction = Output : returns the last written value
**         Note: This component is set to work in Output direction only.
**     Parameters  : None
**     Returns     :
**         ---             - Input value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)

** ===================================================================
*/
#define PTC0_Debug_Pin_GetVal() (BitIoLdd5_GetVal(BitIoLdd5_DeviceData))

/*
** ===================================================================
**     Method      :  PTC0_Debug_Pin_PutVal (component BitIO)
**     Description :
**         This method writes the new output value.
**     Parameters  :
**         NAME       - DESCRIPTION
**         Val             - Output value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)
**     Returns     : Nothing
** ===================================================================
*/
#define PTC0_Debug_Pin_PutVal(Val) (BitIoLdd5_PutVal(BitIoLdd5_DeviceData, (Val)))

/*
** ===================================================================
**     Method      :  PTC0_Debug_Pin_ClrVal (component BitIO)
**     Description :
**         This method clears (sets to zero) the output value.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define PTC0_Debug_Pin_ClrVal() (BitIoLdd5_ClrVal(BitIoLdd5_DeviceData))

/*
** ===================================================================
**     Method      :  PTC0_Debug_Pin_SetVal (component BitIO)
**     Description :
**         This method sets (sets to one) the output value.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define PTC0_Debug_Pin_SetVal() (BitIoLdd5_SetVal(BitIoLdd5_DeviceData))

/*
** ===================================================================
**     Method      :  PTC0_Debug_Pin_NegVal (component BitIO)
**     Description :
**         This method negates (inverts) the output value.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define PTC0_Debug_Pin_NegVal() (BitIoLdd5_NegVal(BitIoLdd5_DeviceData))

/* END PTC0_Debug_Pin. */

#ifdef __cplusplus
}  /* extern "C" */
#endif 

#endif 
/* ifndef __PTC0_Debug_Pin_H */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.5 [05.21]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
